import javafx.animation.FadeTransition;
import javafx.animation.FadeTransitionBuilder;
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Group;
import javafx.scene.Scene;
// import javafx.scene.input.KeyCode;
// import javafx.scene.input.KeyEvent;
import javafx.scene.input.MouseEvent;
import javafx.scene.paint.Color;
import javafx.scene.paint.Stop;
import javafx.scene.shape.Circle;
import javafx.scene.shape.CircleBuilder;
import javafx.stage.Stage;
import javafx.util.Duration;

public class BuilderAtWork extends Application {

	@Override
	public void start(final Stage primaryStage) throws Exception {
		final Group root = new Group();
		final Scene scene = new Scene(root, 600, 450, Color.WHITE);
		primaryStage.setTitle("Hello World");

		Circle[][] circles = new Circle[5][5];
		FadeTransition[][] fts = new FadeTransition[5][5];
		
		final FadeTransitionBuilder ftb = FadeTransitionBuilder
											.create()
											.duration(Duration.millis(2000))
											.fromValue(1.0)
											.toValue(0.0);
		
		final CircleBuilder cb = CircleBuilder.create().radius(20);
		for (int i = 0; i < 5; i++)
			for (int j = 0; j < 5; j++) {
				// final Circle theCircle;
				// final FadeTransition theTransition;
				final Circle theCircle = cb.centerX(100 + 60*i)
											.centerY(100 + 60*j)
											.build();
				circles[i][j] = theCircle;
				theCircle.setFill(Color.color(i*0.2,j*0.2,1.0));
				final FadeTransition theTransition = ftb.build();
				theTransition.setNode(theCircle);
				fts[i][j] = theTransition;
				theTransition.setCycleCount(1);
				// theTransition.setOnFinished(
				// 	ke -> {
				// 		theCircle.setFill(Color.color(i*0.2,j*0.2,1.0));
				// 	});
				// circles[i][j].onMouseEnteredProperty()
				// 	.set(new EventHandler<MouseEvent>() {
				// 		@Override
				// 		public void handle(MouseEvent e) {
				// 			theTransition.play();
				// 		}
				// 	});
				// circles[i][j].onMouseExitedProperty()
				// 	.set(new EventHandler<MouseEvent>() {
				// 		@Override
				// 		public void handle(MouseEvent e) {
				// 			theTransition.pause();
				// 		}
				// 	});
				// circles[i][j].onMouseClickedProperty()
				// 	.set(new EventHandler<MouseEvent>() {
				// 		@Override
				// 		public void handle(MouseEvent e) {
				// 			theCircle.setOpacity(1.0);
				// 		}
				// 	});
				circles[i][j].onMouseEnteredProperty()
					.set(e -> theTransition.play());
				circles[i][j].onMouseExitedProperty()
					.set(e -> theTransition.pause());
				circles[i][j].onMouseClickedProperty()
					.set(e -> theCircle.setOpacity(1.0));
			}
		
		

		for (Circle[] cs: circles)
			root.getChildren().addAll(cs);
		primaryStage.setScene(scene);
		primaryStage.show();
	}

	public static void main(String[] args) {
		launch(args);
	}
}
